using System;
using System.Collections.Generic;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            string niska = Console.ReadLine();
            int pod = niska.Length;

            int q = 0;
            while(q<niska.Length/2 && niska[q]==niska[niska.Length-1-q])
            {
                pod--;
                pod--;
                q++;
            }

            int sviIsti = 0;
            char f = niska[q];
            List<char> podniska = new List<char>(pod);
            for(int l=0;l<pod;l++)
            {
                if (niska[q] == f)
                    sviIsti++;
                podniska.Add(niska[q]);
                q++;
            }
            if(sviIsti==pod)
            {
                Console.WriteLine(1);
            }
            else
            {
                int ii = 1;
                int podd = pod;
                char prvi = podniska[0];
                while (ii < podd)
                {
                    if (podniska[ii] == prvi)
                    {
                        if (ii < podd - 1)
                        {
                            if (podniska[ii] == podniska[ii + 1])
                            {
                                prvi = podniska[ii + 1];
                            }
                            else ii = podd;
                        }
                        podniska.RemoveAt(0);
                        podd--;
                        ii++;
                    }
                    else
                    {
                        podniska.Reverse();
                        prvi = podniska[0];
                    }
                }
                pod = podd;
                Console.WriteLine(pod);
            }
        }
    }
}